//import waba.fx.*;
//import waba.io.*;
import waba.sys.*;    // Convert
import waba.ui.*;
import waba.util.*;   // Vector
import extra.ui.*;    // wextra: Title, List

/**
 * @author <A HREF="mailto:weyer@kagi.com">Steve Weyer</A>
 * Copyright (c) 2001, S. Weyer. All right reserved.
 * @version waba 1.0
 * !!!a 08 Feb 2001
 * <A HREF="http://www.kagi.com/weyer/#Turtle">Steve's other Turtle versions</A>
 * <A HREF="http://www.kagi.com/weyer/#Waba">Steve's other Waba apps</A>
 *
 * ! Newton classHeapSize: 22000
**/

public class Turtle extends MainWindow {
  //final String[] PEN_WIDTHS = {"0", "1", "2", "3"};  // ?? drawLine only width=1

  final String[] EXPRS = {
    "carpet(2,27,90)",        // dist/3
    //"carpet(3,27,90)",        // dist/3
    "cCurve(6,6,0)",
    //"cCurve(8,3,0)",
    "dCurve(6,6,0)",
    //"dCurve(8,4,0)",
    "fractal(2,81,120)",      // dist/3
    //"fractal(3,90,120)",
    "gasket(2,48,120)",       // dist/2
    //"gasket(3,56,120)",
    "hilbert(4,6,90)",
    //"hilbert(5,3,90)",
    "poly(5,35,[])",
    "polySpi(65,10,89)",
    "squiral(8,35,90)",
    "tree(4,48,30)",          // dist*2/3
    //"tree(5,42,30)",
};

//private Button homeButton;
  private Button eraseButton;
  private Check penCheck;
  private boolean penDefault = true;
  private Check visCheck;
  private boolean visDefault = false;

  private TurtleArea turtleArea;

  private Button evalButton;
  private Edit methText;
  private List exprList;

  private Button timesButton;
  private Edit timesText;
  private Button distButton;
  private Edit distText;
  private Button degButton;
  private Edit degText;

  final int COMPHT  = 15;
  final int BUTWID  = 28; // 3+
  final int EDITWID = 24; // 3 across
  final int CHECKWID = 38; // 4 across
  final int COMPSEP = 2;

  public Turtle() {
    // top row: Title, Home, Vis?, Pen?
    int objX = 0, objY = 0, objWid = BUTWID;
    Title title = new Title("Turtle");
    title.setRect(objX, objY, this.width, COMPHT+1);
    add(title);

    objX =45;
    objWid = BUTWID+5;
    eraseButton = new Button("Erase");
    eraseButton.setRect(objX, objY, objWid, COMPHT-2);
    add(eraseButton);

    objX += objWid + COMPSEP;
    objWid = CHECKWID;
    visCheck = new Check("Vis?");
    visCheck.setChecked(visDefault);
    visCheck.setRect(objX, objY, objWid, COMPHT-1);
    add(visCheck);

    objX += objWid + COMPSEP;
    penCheck = new Check("Pen?");
    penCheck.setChecked(penDefault);
    penCheck.setRect(objX, objY, objWid, COMPHT-1);
    add(penCheck);

    // middle area: TurtleArea
    objY = COMPHT+1;
    turtleArea = new TurtleArea(penDefault, visDefault); // this);
    turtleArea.setRect(0, objY, this.width, this.height - (3*objY));
    add(turtleArea);

    // next-to-final row: Eval, [], <Expr>, Erase
    objX = 0;
    objY = this.height - COMPHT*2 - COMPSEP;
    objWid = EDITWID; // swap sizes of Eval & Meth
    evalButton = new Button("Eval");
    evalButton.setRect(objX, objY, objWid, COMPHT);
    add(evalButton);

    objX += objWid + COMPSEP;
    objWid = CHECKWID+10;   // a little wider for meth
    methText = new Edit();
    //methText.setText("weyer@kagi.com");
    methText.setRect(objX, objY, objWid, COMPHT);
    add(methText);

    objX += objWid + COMPSEP;
    exprList = new List(EXPRS);
    //exprList.setSelectedIndex(??);
    exprList.setRect(objX, objY, this.width-objX, COMPHT); // remainder of line
    add(exprList);

    // final row: Times,[], Dist,[], Ang,[]
    objX = 0;
    objY = this.height - COMPHT;
    objWid = BUTWID;
    timesButton = new Button("Times");
    timesButton.setRect(objX, objY, objWid, COMPHT);
    add(timesButton);

    objX += objWid + COMPSEP;
    objWid = EDITWID;
    timesText = new Edit();
    timesText.setText("4");
    timesText.setRect(objX, objY, objWid, COMPHT);
    add(timesText);

    objX += objWid + COMPSEP;
    objWid = BUTWID;
    distButton = new Button("Dist");
    distButton.setRect(objX, objY, objWid, COMPHT);
    add(distButton);

    objX += objWid + COMPSEP;
    objWid = EDITWID;
    distText = new Edit();
    distText.setText("10");
    distText.setRect(objX, objY, objWid, COMPHT);
    add(distText);

    objX += objWid + COMPSEP;
    objWid = BUTWID;
    degButton = new Button("Deg");
    degButton.setRect(objX, objY, objWid, COMPHT);
    add(degButton);

    objX += objWid + COMPSEP;
    objWid = EDITWID;
    degText = new Edit();
    degText.setText("90");
    degText.setRect(objX, objY, objWid, COMPHT);
    add(degText);

  }

  public void onEvent(Event ev) {
    Object obj = ev.target;
    int evType = ev.type;
    int times = Convert.toInt(timesText.getText());
    int dist  = Convert.toInt(distText.getText());
    int deg   = Convert.toInt(degText.getText());
    if (evType == ControlEvent.PRESSED) { // Button
      if (obj == timesButton)
        turtleArea.doEval("poly2", times, dist, deg);
      else if (obj == distButton)
        turtleArea.doEval("go", times, dist, deg);
      else if (obj == degButton)
        turtleArea.doEval("turn", times, dist, deg);
      else if (obj == evalButton)
        turtleArea.doEval(methText.getText(), times, dist, deg);
      else if (obj == exprList) {
        String arg, expr = exprList.getSelected();
        int spos = 0;
        int epos = StringUtil.indexOf(expr,'(',spos);
        turtleArea.erase();
        methText.setText(expr.substring(spos,epos));
        for (int i=0; i < 3; i++) {
          spos = epos+1;
          epos = StringUtil.indexOf(expr, ((i < 2) ? ',' : ')'), spos);
          arg = expr.substring(spos,epos);
          switch (i) {
            case 0:
              timesText.setText(arg);
              break;
            case 1:
              distText.setText(arg);
              break;
            case 2:
              degText.setText(arg);
              break;
          };
        };
      }
      else if (obj == eraseButton)
        turtleArea.erase();
      //else if (obj == homeButton)
      //  turtleArea.home();
      else if (obj == penCheck)
        turtleArea.pen(penCheck.getChecked());
      else if (obj == visCheck)
        turtleArea.setVis(visCheck.getChecked());
    }
  }

  public void setDistDeg(int dist, int deg) { // via TurtleArea.onEvent maybe
    distText.setText(String.valueOf(dist));
    degText.setText(String.valueOf(deg));
  }
}

